package com.io7m.example.ccatpm;

import junit.framework.Assert;

import org.junit.Test;

import com.io7m.example.ccatpm.ArithmeticExpression.ConstantExpression;
import com.io7m.example.ccatpm.ArithmeticExpression.MultiplyExpression;
import com.io7m.example.ccatpm.ArithmeticExpression.PlusExpression;
import com.io7m.example.ccatpm.ArithmeticExpression.SubtractExpression;

public class InterpreterTest
{
  @SuppressWarnings("static-method") @Test public void testAddition()
  {
    final PlusExpression e =
      new PlusExpression(new ConstantExpression(23), new ConstantExpression(
        17));

    Assert.assertEquals(23 + 17, Interpreter.run(e));
  }

  @SuppressWarnings("static-method") @Test public void testConstant()
  {
    final ConstantExpression e = new ConstantExpression(23);

    Assert.assertEquals(23, Interpreter.run(e));
  }

  @SuppressWarnings("static-method") @Test(
    expected = NullPointerException.class) public void testCrash()
  {
    final SubtractExpression e =
      new SubtractExpression(null, new ConstantExpression(17));

    Interpreter.run(e);
  }

  @SuppressWarnings("static-method") @Test public void testMultiplication()
  {
    final MultiplyExpression e =
      new MultiplyExpression(
        new ConstantExpression(23),
        new ConstantExpression(17));

    Assert.assertEquals(23 * 17, Interpreter.run(e));
  }

  @SuppressWarnings("static-method") @Test public void testSubtraction()
  {
    final SubtractExpression e =
      new SubtractExpression(
        new ConstantExpression(23),
        new ConstantExpression(17));

    Assert.assertEquals(23 - 17, Interpreter.run(e));
  }
}
